#include "TrackList.h"
#include <iostream>
#include <conio.h>
#include "ccr.h"
using namespace std;





TrackList::TrackList() {
//************************************************
//   Create a new TrackList
//************************************************
   top = new Node(-1,-1, -1);

   if (top==NULL){
     cout << "Out of Memory... Program will close down";
     getch();
     exit(123);
     }
   top->link = top;               // circle header TrackList

   

} // TrackList


//page
void TrackList::Add (int pc, int to, int sd){
//*******************************************************************
//   Creates a new node on the TrackList from data in
//   "keyval" and "commentval".
//*******************************************************************
   Node *x;            // points to new node
  
   x = new Node(pc, to ,sd);
   if (x==NULL){
     cout << "Out of memory... Program will shut down";
     getch();
     exit(123);
     }
   x-> link = top->link;
   top-> link = x;

} // Add




void TrackList::Print() {
//***********************************************************************
//   Prints (shows) the contents of the TrackList onto the screen.
//***********************************************************************
   Node *p;
   int  nlines;            // line counter
   int  items;             // counts number of items in TrackList
   char opt;

//   clrscr();
   cout << "               L I S T     D A T A\n\n";

   p = top->link;
   nlines = 2;
   items = 0;
   while (p != top) {
      //   TrackList the next item
      nlines++;   items++;
      cout << "photocell: " << p->photocell << " turnout: " << p->turnout 
		   << " switchdirection: " << p->switchdirection <<  "\n";

      //   Check if screen is full
      if (nlines % 22 == 0) {
	 cout << "\nMore? ";   opt = getch();
	 opt = toupper(opt);
	 if (opt == 'N') return;
      }

      //   Advance to next item in the TrackList
      p = p->link;
   } //while

   cout << "\nThere are " << items << " items in the TrackList.";
   cout << "  Press <cr> to continue... ";
   getch();
   cout << endl;

} //Print




void TrackList::Clear() {
/**************************************************************************
	clears all members of the current TrackList
***************************************************************************/

   Node *p,*prev;       // for tag along

   prev=top;
   p = top->link;
   top-> link = top;

   while (p != top) {

      // Advance to next item in the TrackList
      prev=p;
      p = p->link;
      delete prev;


   } //while
   cout << "TrackList has been cleared... Press <Enter>" << endl;
   getch();
}// end clear




int TrackList::FindPCNext(){


		Node * p;

	   	p = top->link;

		if (p->turnout == -1)
				return (p->photocell);

		else if (p->switchdirection == Get_TO_Status(p->turnout))
				return(p->photocell);
				
		else if (p->link == top)
				return  -1; 
				

		else{
			p  = p->link;
			if (p->switchdirection == Get_TO_Status(p->turnout))
					return ( p->photocell );
				
			else
				    return  -1;
				
			}

}




int TrackList::FindPCNext(int switchdirection){

		Node * p;

	   	p = top->link;

		
		if (p->turnout == -1)
				return (p->photocell);

		else if (p->switchdirection == switchdirection)
				return(p->photocell);
				
		else if (p->link == top)
				return  -1; 
				

		else{
			p  = p->link;
			if (p->switchdirection == switchdirection)
					return ( p->photocell );
				
			else
				    return  -1;
				
			}

}



int TrackList::FindToNext(){

		Node * p;

	   	p = top->link;

		
		if (p->turnout == -1)
			return -1;

		else 
			return p->turnout;

	


}



int TrackList::FindSwitchDirection(int pc)
{

		Node * p;

	   	p = top->link; // get top of list to start to search
		
		if (p->turnout == -1 && p->photocell == pc)
				return (p->switchdirection);
	
		else if (p->photocell == pc)
				return(p->switchdirection);
					
		else if (p->link == top)
				return 0; 
	
		else
		{
			p  = p->link; 
			//not in the first node go to the second node

			if (p->photocell == pc)
					return ( p->switchdirection);		
			else return  0;
		}


}



/*


void main(){


	Turnouts[0]	= STRAIGHT;
	Turnouts[1] = STRAIGHT;
	Turnouts[2]	= STRAIGHT;
	Turnouts[3] = CURVED;
	Turnouts[4] = CURVED;
	Turnouts[5] = CURVED;
	Turnouts[6] = CURVED;

	TrackList CW[MAXPHOTOCELLS];
	TrackList CC[MAXPHOTOCELLS];

	CW[0].Add(2,1,STRAIGHT);
	CW[1].Add(2,1,CURVED);
	CW[2].Add(7,-1,NOTURNOUT);
	CW[3].Add(1,0,STRAIGHT);
	CW[4].Add(12,6,STRAIGHT);
	CW[4].Add(12,6,CURVED);
	CW[5].Add(4,-1,NOTURNOUT);
//	CW[6].Add(12,-1,NOTURNOUT);
	CW[7].Add(15,2,STRAIGHT);
	CW[8].Add(0,-1,NOTURNOUT);
	CW[9].Add(3,-1,NOTURNOUT);
//	CW[10].Add(-1,-1,NOTURNOUT);
	CW[11].Add(5,6,CURVED);
	CW[11].Add(5,6,STRAIGHT);
	CW[12].Add(15,2,CURVED);
	CW[13].Add(8,4,STRAIGHT);
	CW[13].Add(9,4,CURVED);
	CW[14].Add(11,-1,NOTURNOUT);
	CW[15].Add(13,3,STRAIGHT);
	CW[15].Add(14,3,CURVED);


	CC[0].Add(8,-1,NOTURNOUT);
	CC[1].Add(3,0,STRAIGHT);
	CC[2].Add(1,1,CURVED);
	CC[2].Add(0,1,STRAIGHT);
	CC[3].Add(9,-1,NOTURNOUT);
	CC[4].Add(5,-1,NOTURNOUT);
	CC[5].Add(11,6,STRAIGHT);
	CC[5].Add(11,6,CURVED);
//	CC[6].Add(5,-1,NOTURNOUT);
	CC[7].Add(2,-1,STRAIGHT);
	CC[8].Add(13,4,STRAIGHT);
	CC[9].Add(13,4,CURVED);
//	CC[10].Add(-1,-1,-1,NOTURNOUT);
	CC[11].Add(14,-1,NOTURNOUT);
	CC[12].Add(4,6,STRAIGHT);
	CC[12].Add(4,6,CURVED);
	CC[13].Add(15,3,STRAIGHT);
	CC[14].Add(15,3,CURVED);
	CC[15].Add(7,2,STRAIGHT);
	CC[15].Add(12,2,CURVED);



	cout << "With State" << endl;

	for (int i = 0; i< 16; i++){
		cout << "Clockwise of " << i << " is :" <<  CW[i].FindPCNext() << " ";
		cout << "Counter Clockwise of " << i << " is: " << CC[i].FindPCNext() << endl;
		getch();
	}


	cout << endl << "Staight" << endl;

	for (i = 0; i< 16; i++){
		cout << "Clockwise of " << i << " is :" <<  CW[i].FindPCNext(STRAIGHT) << " ";
		cout << "Counter Clockwise of " << i << " is: " << CC[i].FindPCNext(STRAIGHT) << endl;
		getch();
	}

	cout << endl << "Curved" << endl;

	for (i = 0; i< 16; i++){
		cout << "Clockwise of " << i << " is :" <<  CW[i].FindPCNext(CURVED) << " ";
		cout << "Counter Clockwise of " << i << " is: " << CC[i].FindPCNext(CURVED) << endl;
		getch();
	}

	cout << endl << "Moving" << endl;

	for (i = 0; i< 16; i++){
		cout << "Clockwise of " << i << " is :" <<  CW[i].FindPCNext(MOVING) << " ";
		cout << "Counter Clockwise of " << i << " is: " << CC[i].FindPCNext(STRAIGHT) << endl;
		getch();
	}

	cout << endl << "Next TO" <<endl;

	for (i = 0; i< 16; i++){
		cout << "Clockwise of " << i << " is :" <<  CW[i].FindToNext() << " ";
		cout << "Counter Clockwise of " << i << " is: " << CC[i].FindToNext() << endl;
		getch();
	}
	





}

  */

