// TRACK.CPP

#include "track.h"
#include "iostream.h"
#include "fstream.h"
//#include "dcc_comm.cpp"


Track::Track(){

	int i;
	// Initilize sensors
	for(i=0; i< MAX_SENSOR; i++){
		sensor[i].type = i%4;
		sensor[i].ID =	i;
		sensor[i].turn = i/4;
		sensor[i].val = false;
		sensor[i].changed = false;
	}
	for(i=0; i< MAX_TURN; i++){
		turnout[i].straight.me = i%4;
		turnout[i].left.me = i%4+1;
		turnout[i].right.me = i%4+2;
		//next sensor undefined at this time
		turnout[i].straight.next = -1;
		turnout[i].left.next = -1;
		turnout[i].right.next = -1;

		turnout[i].tort.state = false;
		turnout[i].tort.ID = i;
		turnout[i].tort.sensor = i%4+3;

		turnout[i].tort.Throw(false, dcc);
	}




}
	

void Track::GetSensors(){
	/*
	This function takes in two arrays of type bool. The array Sensors contains the actual
	value of the sensors at read time. The array changed indicates which sensors have changed since last
	read. It then reads all the inputs off of all the AIU units and places them in the arrays
	so that each sensor has its own zero-based index.
	*/
	//bool Sensors[MAX_SENSOR];
	//bool Changed[MAX_SENSOR];

	//fstream err;
	//err.open("error.log", ios::out | ios::ate);

	char buffer[4];
	
	char temp;

	unsigned long DCC_Handle = dcc;
	

	unsigned char  mask = 1;

	int i;
	// Iterate through AIUs and place bit values into sensor arrays
	for(i=MIN_AIU; i <= MAX_AIU; i++){
		if(!GetAIU(buffer, i, DCC_Handle)){
			//Error
			//err << "GetAIU() CALL FAILED\n";
		}
		
		// have to swap high and low bytes or something
		temp = buffer[0];
		buffer[0] = buffer[1];
		buffer[1] = temp;
		temp = buffer[2];
		buffer[2] = buffer[3];
		buffer[3] = temp;


		int j;
		//Extract Bits from returned bytes
		for(j=0; j<14; j++){
			// bits 1-8 in buffer[0], bits 9-14 in buffer[1]
			// division by 8 should switch from [0] to [1] when appropriate
			if( buffer[j/8] & mask){ // True if mask bit sits on a lit bit in buffer[j/8]
				
				// Translate AIU number and bit number into a zero based index
				// Store True in Sensors[index]
				// for whatever reason the current state of the sensor is 
				// reported as the opposite of state of input( on = false)
				//Sensors[((i-MIN_AIU)*14)+j] = false;
				sensor[((i-MIN_AIU)*14)+j].val = false;

			}else{
				// Not true so set false
				//Sensors[((i-MIN_AIU)*14)+j] = true;
				sensor[((i-MIN_AIU)*14)+j].val  = true;
			}

			// bits 1-8 in buffer[2], bits 9-14 in buffer[3]
			// division by 8 should switch from [2] to [3] when appropriate
			if( buffer[(j/8)+2] & mask){ // True if mask bit sits on a lit bit in buffer[j/8+2]

				// Translate AIU number and bit number into a zero based index
				// Store True in Sensors[index]
				//Changed[((i-MIN_AIU)*14)+j] = true;
				sensor[((i-MIN_AIU)*14)+j].changed  = true;
			}else{
				// Not true so set false
				sensor[((i-MIN_AIU)*14)+j].changed = false;
			}

			// shift mask bit left 1
			mask = mask << 1;
			// if mask is zero start back at one
			if(mask==0) mask=1;


		}
	}

	//err.close();
	//err.clear();


}

void Decoder::Throw(bool val, unsigned long dcc){
	
	state = val;
	acc_decoder(dcc, ID, val);
}
