﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.DirectX.DirectInput;

namespace JoystickControl
{
    public partial class Joy : Form
    {
        Device joystick;

        public Joy()
        {
            InitializeComponent();
            pollTimer.Interval = 50;
            try
            {
                DeviceList deviceList = Manager.GetDevices(DeviceClass.GameControl, EnumDevicesFlags.AttachedOnly);
                
                    if(deviceList.Count > 0)
                    {
                        string[] systemJoysticks = new string[deviceList.Count];
                        int i = 0;
                        foreach (DeviceInstance deviceInstances in deviceList)
                        {
                            joystick = new Device(deviceInstances.InstanceGuid);
                            joystick.SetCooperativeLevel(this.Handle, CooperativeLevelFlags.Background | CooperativeLevelFlags.NonExclusive);
                            systemJoysticks[i] = joystick.DeviceInformation.InstanceName;
                            deviceListBox.Items.Add(systemJoysticks[i].ToString());
                            i++;
                        }
                        deviceListBox.SelectedIndex = 0;
                    }

             }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }
        
        private void deviceListBox_DoubleClick(object sender, EventArgs e)
        {
            try
            {
                DeviceList deviceList = Manager.GetDevices(DeviceClass.GameControl, EnumDevicesFlags.AttachedOnly);

                if (deviceList.Count > 0)
                {
                    string[] systemJoysticks = new string[deviceList.Count];
                    foreach (DeviceInstance deviceInstances in deviceList)
                    {
                        if (deviceListBox.SelectedIndex.ToString() == deviceInstances.InstanceName)
                        {
                            joystick = new Device(deviceInstances.InstanceGuid);
                            joystick.SetCooperativeLevel(this.Handle, CooperativeLevelFlags.Background | CooperativeLevelFlags.NonExclusive);
                        }
                    }
                }

                MessageBox.Show("Using " + joystick.DeviceInformation.InstanceName);

                joystick.SetDataFormat(DeviceDataFormat.Joystick);
                joystick.Acquire();
                pollTimer.Start();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void joystickSelectButton_Click(object sender, EventArgs e)
        {
            deviceListBox_DoubleClick(sender, e);
        }

        private void pollTimer_Tick(object sender, EventArgs e)
        {

            statusBox.Items.Clear();
            buttonStatusBox.Items.Clear();
            buttonListbox.Items.Clear();
            button1.Checked = false;
            button2.Checked = false;
            button3.Checked = false;
            button4.Checked = false;

            //   actually READ device
            joystick.Poll();

            JoystickState state = joystick.CurrentJoystickState;

            statusBox.Items.Add("x: " + state.X + " y: " + state.Y + " z: " + state.Z);
            xStrengthBar.Value = state.X;
            if ((state.Z > 32768 && state.Z > state.Y) || (state.Z < 32767 && state.Z < state.Y))
                yzStrengthBar.Value = -1 * state.Z;
            else
                yzStrengthBar.Value = -1 * state.Y;
            buttonStatusBox.Items.Add(state.GetButtons()[0].ToString() + " " + state.GetButtons()[1].ToString() + " " + state.GetButtons()[2].ToString() + " " + state.GetButtons()[3].ToString());

            string ss = "";
            for (int i = 0; i < state.GetButtons().Length; i++)
                ss = ss + state.GetButtons()[i].ToString() + "  ";

            buttonListbox.Items.Add(ss);

            if (state.GetButtons()[0] > 0)
                button1.Checked = true;
            if (state.GetButtons()[1] > 0)
                button2.Checked = true;
            if (state.GetButtons()[2] > 0)
                button3.Checked = true;
            if (state.GetButtons()[3] > 0)
                button4.Checked = true; 
        }
    }
}
