////////////////////////////////////////////////////////
//This file provides wrapper functions and a global unsigned long
//DCC_comm to act as the handle for comm communication for the DCC
//commands to move the train
////////////////////////////////////////////////////////////////////


#include "DCC_comm.h"
#include "MyDcc.h"

unsigned long DCC_comm;  //declare our global handle


////////////////////////////////////////////////////////////
//all functions are wrappers of functions pointed to by the
//dccbetter.lib and implemented in the dccbetter.dll
/////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////
//opens the comm port and assigns a value to the DCC_com global long
////////////////////////////////////////////////////////////
int _stdcall MyDCC_open( char comportnumber[])
{

	return (DCC_open(comportnumber, DCC_comm));
		
}

///////////////////////////////////////////////////////////////
//closes the comm port
/////////////////////////////////////////////////////////////
void _stdcall MyDCC_close()
{

   DCC_close(DCC_comm);


}


////////////////////////////////////////////////////////////////
//Sends a motor command to the Train.  Used to adjust speed, change 
//direction, or stop (by giving a speed of 0)
//////////////////////////////////////////////////////////////////
int _stdcall MyDCC_motor(int id, int dir, int speed)
{


	return (DCC_motor(DCC_comm, id, dir, speed));

}


/*
int _stdcall MyDCC_Estop(int id, int dir)
{

	return (DCC_Estop(DCC_comm));



}
*/
/*

int _stdcall MyDCC_function(int train_id, int &fcn_state, 
				 int fcn_id, int value)
{

	return(DCC_function(DCC_comm, train_id, fcn_state, fcn_id, value));


}

*/

//////////////////////////////////////////////////////////////////
//sends a kill command to the entire track - no commands are sent to the
//track
//////////////////////////////////////////////////////////////////////////
int _stdcall MyDCC_kill()
{

	return(DCC_kill(DCC_comm));


}

//////////////////////////////////////////////////////////////////////////
//resets the system one boxes to send commands---needs to be sent after 
//the MyDCC_kill() command in order to start issuing train commands
//again
///////////////////////////////////////////////////////////////////////////
int _stdcall MyDCC_reset()
{

	return(DCC_reset(DCC_comm));


}

//bool DCC_testcommands(int & testvalue);
// UNDER CONSTRUCTION
// This fcn should walk the user through a series of tests
// to check out the connections from the comm port to the cmd station,
// from the cmd station to a decoder, and basic functions on a decoder.
// **********************************************************************************


//bool DCC_command( char cmd_str[]);
// UNDER CONSTRUCTION
// This fcn would send ANY command to the cmd station.
// Issues -- should it be the binary or ascii format??
// Should it compute the cksum?
// **********************************************************************************

// *********************************************************************************
// *********************************************************************************

// END DCC_comm.h
// ***********************************************************************************


