#include <afxwin.h>
#include "CTrainControl.h"
#include "Constants.h"
#include "Train.h"



CTrainControl::CTrainControl(Train * T, ResourceManager * R)
{

	char Title[30];

	ResMng = R;

	Q = T;


	strcpy(Title, "Train Contol ");
	strcat(Title, T->GetName());

	CRect Rect(0,0,500, 500);  //define oringal window
	Create(0, Title, WS_OVERLAPPEDWINDOW, Rect, NULL, 0);  //create new window

 	CRect MyRect(0, 0, m_cxChar*45,  m_cyChar * 20); 
	// comes back with m_cxChar and my_cyChar defined set up new rect for new window
										

	CalcWindowRect(&MyRect);  // calc pixel width and height for window

	SetWindowPos(NULL, 0, 0, MyRect.Width() , MyRect.Height(), 
		         SWP_NOZORDER | SWP_NOMOVE | SWP_NOREDRAW);



//	SetTimer( 2, 1000, NULL ); // set timer for every second


}



CTrainControl::~CTrainControl()
{



}





int CTrainControl::OnCreate(LPCREATESTRUCT lpcs)
{

	

	if (CWnd::OnCreate(lpcs) == -1)
		return -1; //return if not good



	char IdMessage[20];
	char TempId[5];
	strcpy(IdMessage, "Train ID:");
	itoa(Q->GetId(), TempId, 10);
	strcat(IdMessage, TempId);

	m_font.CreatePointFont(65, _T("MS Sans Serif"));  //select our font
	CClientDC dc (this);  //get handler to compute text averages
	CFont * pOldFont = dc.SelectObject(&m_font); // select our font

	TEXTMETRIC Tm; // get Textmetric

	dc.GetTextMetrics(&Tm);  // and give it our font to calculate
	m_cxChar = Tm.tmAveCharWidth;  // store average width
	m_cyChar = Tm.tmHeight + Tm.tmExternalLeading;	// and height

	dc.SelectObject(pOldFont); // return old pen to not consume resources

	CRect rect;
		
	rect.SetRect (m_cxChar * 1, m_cyChar * 7, m_cxChar * 17, m_cyChar * 9);
    ChangeDirectionButton.Create (_T ("Change Direction"), WS_CHILD | WS_VISIBLE |
         BS_PUSHBUTTON, rect, this, IDC_CHANGEDIRECTIONBUTTON);

	rect.SetRect (m_cxChar * 23, m_cyChar * 3, m_cxChar * 28, m_cyChar * 5);
    StopButton.Create (_T ("Stop"), WS_CHILD | WS_VISIBLE |
         BS_PUSHBUTTON, rect, this, IDC_STOPBUTTON);

	rect.SetRect (m_cxChar * 23, m_cyChar * 7, m_cxChar * 37, m_cyChar * 9);
    HeadLightToggleButton.Create (_T ("HeadLight Off"), WS_CHILD | WS_VISIBLE |
         BS_PUSHBUTTON, rect, this, IDC_HEADLIGHTTOGGLEBUTTON);

	rect.SetRect (m_cxChar * 23, m_cyChar * 10, m_cxChar * 37, m_cyChar * 12);
    TailLightToggleButton.Create (_T ("TailLight Off"), WS_CHILD | WS_VISIBLE |
         BS_PUSHBUTTON, rect, this, IDC_TAILLIGHTTOGGLEBUTTON);

	 rect.SetRect (m_cxChar * 1, m_cyChar * 1, m_cxChar * 13, m_cyChar * 3);
	 IdText.Create (_T (IdMessage), WS_CHILD | WS_VISIBLE | SS_CENTER, rect,
        this, IDC_IDTEXT);


	ChangeDirectionButton.SetFont (&m_font, FALSE);
	StopButton.SetFont (&m_font, FALSE);
	TailLightToggleButton.SetFont (&m_font, FALSE);
	HeadLightToggleButton.SetFont (&m_font, FALSE);
	IdText.SetFont (&m_font, FALSE);
	return 0;


}//Oncreate



afx_msg void CTrainControl::OnPaint()
{


   CPaintDC dc( this );   //get paint handler
   
 
}//OnPaint




afx_msg void CTrainControl::OnDestroy()
{

     
//	KillTimer( 2 );   //kill timer 1

}





afx_msg void CTrainControl::OnTimer()
{


  

	

}


afx_msg void CTrainControl::OnStop()
{

	ResMng->Stop(Q->GetId());


}


afx_msg void CTrainControl::OnChangeDirection()
{

	ResMng->ChangeDirection(Q->GetId());


}


afx_msg void CTrainControl::OnHeadLightToggle()
{


	char temp[10];

	itoa(Q->GetId(), temp, 10);
	MessageBox(temp);

	if (Q->GetHeadLight() == ON)
	{
		HeadLightToggleButton.SetWindowText("HeadLight Off");
		MessageBox("HI");

	}
	else
	{
		HeadLightToggleButton.SetWindowText("HeadLight On");
		MessageBox("Here");
	}
		
	ResMng->ToggleHeadLight(Q->GetId());


}


afx_msg void CTrainControl::OnTailLightToggle()
{

	if (Q->GetTailLight() == ON)
		TailLightToggleButton.SetWindowText("TailLight Off");
	else
		TailLightToggleButton.SetWindowText("TailLight On");

	ResMng->ToggleTailLight(Q->GetId());

}


BEGIN_MESSAGE_MAP(CTrainControl, CFrameWnd)

	
	ON_WM_CREATE()

	ON_WM_TIMER()    

	ON_WM_PAINT()   

	ON_COMMAND(IDC_STOPBUTTON, OnStop)

	ON_COMMAND(IDC_CHANGEDIRECTIONBUTTON, OnChangeDirection)

	ON_COMMAND(IDC_HEADLIGHTTOGGLEBUTTON, OnHeadLightToggle)

	ON_COMMAND(IDC_TAILLIGHTTOGGLEBUTTON, OnTailLightToggle)

	
END_MESSAGE_MAP()