#if !defined TRAIN_H

#define TRAIN_H

const int BATCH = 0;
const int INTERACTIVE = 1;

const int CLOCKWISE = 1;
const int COUNTERCLOCKWISE = 0;
const int FORWARD = 1;
const int REVERSE = 0;

const int DEFMAXSPEED = 10;

const int DEFDIRECTIONAROUNDTRACK = CLOCKWISE;
const int DEFDIRECTION = FORWARD;

const int ON = 1;
const int OFF = 0;

const int DEFPHOTOCELLHAS = 8;
const int DEFPHOTOCELLNEXT = 0;
const int DEFTURNOUTHAS = -1;
const int DEFOLDPHOTOCELLHAS = 13;
const int DEFOLDTURNOUTHAS = 4;
const int SENTCOMMAND = 1;
const int QUEUECOMMAND = 0;


class Train
{
public:

	//Train(int id, int Maxspeed, int Mode);

	Train(int Id1, int Mode1, int MaxSpeed1 = 16 , int PhotocellHas1 = DEFPHOTOCELLHAS,
		  int PhotocellNext1 = DEFPHOTOCELLNEXT, int TurnoutHas1 = DEFTURNOUTHAS, 
		  int OldPhotocellHas1 = DEFOLDPHOTOCELLHAS, int OldTurnoutHas1 = DEFOLDTURNOUTHAS,
		  int BlockingPhotocell1 = -1, int BlockingTurnout1 = -1, 
		  int DirectionAroundTrack1 = CLOCKWISE,  int Direction1 = FORWARD, 
		  int HeadLight1 = OFF, int TailLight1 = OFF);


	Train( const Train & T);

	virtual ~Train();

	int GetId();

	int GetSpeed();
	int SetSpeed(int newspeed);

	int IncreaseSpeed(int increment);
	int IncreaseSpeed();

	int DecreaseSpeed(int increment);
	int DecreaseSpeed();

	int Stop();

	int ChangeDirection();

	int GetPhotocellHas();
	int FindNextPhotoCell();


	int GetLastPhotocellCovered();

	int GetPhotocellNext();

	int GetTurnoutHas();

	int GetBlockingPhotocell();

	int GetBlockingTurnout();

	int GetDirectionAroundTrack();
	void SetDirectionAroundTrack(int DirectionAroundTrack);

	int GetDirection();

	int TurnHeadLightOn(int on);
	int ToggleHeadLight();

	int TurnTailLightOn(int on);
	int ToggleTailLight();

	int GetMode();

	void Print();

	Train * link;



	friend class ResourceManager;
	



private:

	int Id;

	int Speed;
	int MaxSpeed;

	int OldPhotocellHas;
	int PhotocellHas;
	int PhotocellNext;
	int TurnoutHas;
	int OldTurnoutHas;
	int LastPhotocellCovered;

	int DirectionAroundTrack;
	int Direction;

	int HeadLight;
	int TailLight;

	int Mode;

	int BlockingPhotocell;
	int BlockingTurnout;

	char DCCLastCommand[15];
	
};

#endif


