#if !defined TRAIN_H

#define TRAIN_H

const int BATCH = 0;
const int INTERACTIVE = 1;

const int CLOCKWISE = 1;
const int COUNTERCLOCKWISE = 0;
const int FORWARD = 1;
const int REVERSE = 0;

const int DEFMAXSPEED = 10;

const int DEFDIRECTIONAROUNDTRACK = CLOCKWISE;
const int DEFDIRECTION = FORWARD;

const int ON = 1;
const int OFF = 0;

const int DEFPHOTOCELLHAS = 8;
const int DEFPHOTOCELLNEXT = 0;
const int DEFTURNOUTHAS = -1;

const int SENTCOMMAND = 1;
const int QUEUECOMMAND = 0;


class Train
{
public:

	Train(int id, int Maxspeed, int Mode);

	Train(int Id1, int MaxSpeed1, int Speed1, int PhotocellHas1, int PhotocellNext1,
			 int TurnoutHas1, int BlockingPhotocell1, int BlockingTurnout, int DirectionAroundTrack1, 
			 int Direction1, int HeadLight1, int TailLight1, char * LastCommand1);

	virtual ~Train();

	int GetId();

	int GetSpeed();
	int SetSpeed(int newspeed);

	int IncreaseSpeed(int increment);
	int IncreaseSpeed();

	int DecreaseSpeed(int increment);
	int DecreaseSpeed();

	int Stop();

	int ChangeDirection();

	int GetPhotocellHas();
	int FindNextPhotoCell();


	int GetPhotocellNext();

	int GetTurnoutHas();

	int GetBlockingPhotocell();

	int GetBlockingTurnout();

	int GetDirectionAroundTrack();
	void SetDirectionAroundTrack(int DirectionAroundTrack);

	int GetDirection();

	int TurnHeadLightOn(int on);
	int ToggleHeadLight();

	int TurnTailLightOn(int on);
	int ToggleTailLight();

	int GetMode();

	void Print();

	Train * link;

	int BlockingPhotocell;
	int BlockingTurnout;

	friend class ResourceManager;
	



private:

	int Id;

	int Speed;
	int MaxSpeed;

	int PhotocellHas;
	int PhotocellNext;
	int TurnoutHas;

	int DirectionAroundTrack;
	int Direction;

	int HeadLight;
	int TailLight;

	int Mode;

	char LastCommand[15];
	
};

#endif


