#include <iostream>
#include <conio.h>
#include "trainlist.h"
#include "ResourceManager.h"
#include "Train.h"
#include "TrackList.h"
#include "Node.h"

using namespace std;



TrainList::TrainList(){


	
   top = new Train(9999,0, INTERACTIVE);
   if (top==NULL){
     cout << "Out of Memory... Program will close down";
     getch();
     exit(123);
     }
   top->link = top;               // circle header list
  
} // List






TrainList::~TrainList(){

	//Clear();

}


void TrainList::Add(Train * T){

		   
	        Train *prev,*p;      // used for tag along

		//   Add to the front of the list

			prev=top;
			p = top->link;

			while (T->GetId() > p->GetId()){
				prev=p;                    // find location to enter new node
				p=p-> link;
			}// end while

				
			T->link = p;
			prev-> link = T;

	


}

	
Train *  TrainList::Delete( int id) {
//*******************************************************************
//   Deletes the node with "keyval" from this list.
//*******************************************************************
	Train *prev, *p;          // used for tag along

	prev=top;
	p=top-> link;

	while (p!=top){

		if (p->GetId() == id){
		    prev-> link =p -> link;

			Train * t = p;
		    delete p;
			return t;
		}

	  prev=p;
	  p=p->link;
	}

	return NULL;

} // Delete





void TrainList::Clear(){


   Train *p,*prev;       // for tag along

   prev=top;
   p = top->link;
 //  top-> link = top;

   while (p != top) {

      // Advance to next item in the list
      prev=p;
      p = p->link;
      delete prev;


   } //while
   cout << "List has been cleared... Press <Enter>" << endl;
   getch();
}// end clear



Train * TrainList::Find(int id){


	Train *prev, *p;          // used for tag along

	prev=top;
	p=top-> link;

	while (p!=top){

		if (p->GetId() == id){
			return p;
		}

	  prev=p;
	  p=p->link;
	}

//	cout << id << " was not found in list";
//	getch();
	return NULL;


}





void TrainList::Print(){


   Train *p;
   int  nlines;            // line counter
   int  items;             // counts number of items in list
   char opt;


   cout << "               L I S T     D A T A\n\n";

   p = top->link;
   nlines = 2;
   items = 0;
   while (p != top) {
      //   List the next item
      nlines++;   items++;
      p->Print();

      //   Check if screen is full
      if (nlines % 2 == 0) {
	 cout << "\nMore? ";   opt = getch();
	 opt = toupper(opt);
	 if (opt == 'N') return;
      }

      //   Advance to next item in the list
      p = p->link;

   } //while

   cout << "\nThere are " << items << " items in the list.";
   cout << "  Press <cr> to continue... ";
   getch();
   cout << endl;

} //Print


/*


void main(){

	ResourceManager * MY;
	MY = new ResourceManager;

	TrainList X;
	
	TrackList Y;

	X.Add(MY, 2, 4);

	X.Print();

	Train * P = X.Find(2);

	P->Print();

	MY->PrintResourceTables();

	X.Delete(MY, 2);

	X.Print();


}


*/


