Attribute VB_Name = "TortService"
Option Explicit
    
Private Declare Function Open_Ports Lib "c:\ccr.dll" () As Integer
Private Declare Function Initialize_Board Lib "c:\ccr.dll" (ByVal BoardNum As Integer, ByVal a As Integer, ByVal b As Integer, ByVal cl As Integer, ByVal ch As Integer) As Integer
Private Declare Function TO_Toggle Lib "c:\ccr.dll" (ByVal TortNum As Integer) As Integer
Private Declare Function Get_TO_Status Lib "c:\ccr.dll" (ByVal TortNum As Integer) As Integer
Private Declare Function Get_Sensor_Status Lib "c:\ccr.dll" (ByVal SensorNum As Integer) As Integer

Public Sub Initialize()
    
    Dim PortStatus As Integer
    Dim InitStatus As Integer

    PortStatus = Open_Ports()
    
    ' Initialize Board #1 To Output
    InitStatus = Initialize_Board(1, 0, 0, 0, 0)
    
    ' Initialize Board #2 To Input
    InitStatus = Initialize_Board(2, 1, 1, 1, 1)
    
    ' Initialize Board #3 To Input
    InitStatus = Initialize_Board(3, 1, 1, 1, 1)
        
    ' Initialize Board #4 To Input
    InitStatus = Initialize_Board(4, 1, 1, 1, 1)
     
End Sub

Public Function Call_Get_Sensor(SensorNum As Integer) As Integer
'************************************************************************************
' Function recieves the tortoise number and calls the C function that gets
' the status of the photo cell.  It returns 1 if shadowed (loco present) and
' a 0 if not shadowed.
'************************************************************************************

    Dim RetVal As Integer  'Integer returned by the C function
    
    'Call C function to get photocell status
    RetVal = Get_Sensor_Status(SensorNum)
    
    Call_Get_Sensor = RetVal
    
End Function

Public Function Call_Toggle_Tort(TortNum As Integer) As Boolean

'************************************************************************************
'  Function recieves the tortoise number and calls the C function that toggles the
'  tortoise to the opposite positon.  It returns a value of 1 if successful and a
'  value of 0 if unsuccessful.
'************************************************************************************
    
    Dim RetVal As Integer  'Integer Returned by the C function
    Dim Success As Boolean
    
    'Call C function that toggles the tortoise
    RetVal = TO_Toggle(TortNum)
    
    If RetVal = 1 Then
        Success = True
    ElseIf RetVal = 0 Then
        Success = False
    End If
   
    Call_Toggle_Tort = Success 'Return true for testing
    
End Function

Public Function Call_Check_Tort(TortNum As Integer) As Integer
'************************************************************************************
'  Function recirves the tortoise number and calls the C function that returns its
'  position status.  It returns a value of 1 if turnout positions towards outside
'  track, 0 if in the middle, or -1 if toward inside of track
'************************************************************************************
    
    Dim RetVal As Integer
    
    'Call the C function to get the turnout position status
    RetVal = Get_TO_Status(TortNum)
   
    Call_Check_Tort = RetVal
    
End Function

Public Sub Display_Status(CellNum As Integer, Status As Integer)
     
     With frmControl
     
     Select Case CellNum
     
        Case 0   'Cell 0
            If Status = 1 Then
                .Cell0.Visible = True
        
            ElseIf Status = 0 Then
                .Cell0.Visible = False
            
            End If
    
        Case 1 'Cell 1
            If Status = 1 Then
                .Cell1.Visible = True
        
            ElseIf Status = 0 Then
                .Cell1.Visible = False
            
            End If
    
        Case 2 'Cell 2
            If Status = 1 Then
                .Cell2.Visible = True
        
            ElseIf Status = 0 Then
                .Cell2.Visible = False
            
            End If
    
        Case 3 'Cell 3
            If Status = 1 Then
                .Cell3.Visible = True
        
            ElseIf Status = 0 Then
                .Cell3.Visible = False
            
            End If
    
        Case 4 'Cell 4
            If Status = 1 Then
                .Cell4.Visible = True
        
            ElseIf Status = 0 Then
                .Cell4.Visible = False
            
            End If
    
        Case 5 'Cell 5
            If Status = 1 Then
                .Cell5.Visible = True
        
            ElseIf Status = 0 Then
                .Cell5.Visible = False
            
            End If
        Case 6 'Cell 6
            If Status = 1 Then
                .Cell6.Visible = True
        
            ElseIf Status = 0 Then
                .Cell6.Visible = False
            
            End If
    
        Case 7 'Cell 7
            If Status = 1 Then
                .Cell7.Visible = True
        
            ElseIf Status = 0 Then
                .Cell7.Visible = False
            
            End If
       
    End Select
    
    End With
    
End Sub
Public Sub Fill_Turn(FillNum As Integer, Pos As Integer)
     
     With frmControl
     
     Select Case FillNum
     
        Case 0   'tortoise 0
            If Pos = -1 Then
                .Turn0_Out.FillColor = vbGreen
                .Turn0_In.FillColor = vbRed
        
            ElseIf Pos = 1 Then
                .Turn0_In.FillColor = vbGreen
                .Turn0_Out.FillColor = vbRed
        
            Else
                .Turn0_In.FillColor = vbYellow
                .Turn0_Out.FillColor = vbYellow
            
            End If
    
        Case 1 'tortoise 1
            If Pos = -1 Then
                .Turn1_Out.FillColor = vbGreen
                .Turn1_In.FillColor = vbRed
        
            ElseIf Pos = 1 Then
                .Turn1_In.FillColor = vbGreen
                .Turn1_Out.FillColor = vbRed
        
            Else
                .Turn1_In.FillColor = vbYellow
                .Turn1_Out.FillColor = vbYellow
            
            End If
        
        Case 2 'tortoise 2
            If Pos = -1 Then
                .Turn2_Out.FillColor = vbGreen
                .Turn2_In.FillColor = vbRed
        
            ElseIf Pos = 1 Then
                .Turn2_In.FillColor = vbGreen
                .Turn2_Out.FillColor = vbRed
        
            Else
                .Turn2_In.FillColor = vbYellow
                .Turn2_Out.FillColor = vbYellow
            
            End If
        
        Case 3 'tortoise 3
            If Pos = -1 Then
                .Turn3_Out.FillColor = vbGreen
                .Turn3_In.FillColor = vbRed
        
            ElseIf Pos = 1 Then
                .Turn3_In.FillColor = vbGreen
                .Turn3_Out.FillColor = vbRed
        
            Else
                .Turn3_In.FillColor = vbYellow
                .Turn3_Out.FillColor = vbYellow
            
            End If
        
        Case 4 'tortoise 4
            If Pos = -1 Then
                .Turn4_Out.FillColor = vbGreen
                .Turn4_In.FillColor = vbRed
        
            ElseIf Pos = 1 Then
                .Turn4_In.FillColor = vbGreen
                .Turn4_Out.FillColor = vbRed
        
            Else
                .Turn4_In.FillColor = vbYellow
                .Turn4_Out.FillColor = vbYellow
            
            End If
        
        Case 5 'tortoise 5
            If Pos = -1 Then
                .Turn5_Out.FillColor = vbGreen
                .Turn5_In.FillColor = vbRed
        
            ElseIf Pos = 1 Then
                .Turn5_In.FillColor = vbGreen
                .Turn5_Out.FillColor = vbRed
        
            Else
                .Turn5_In.FillColor = vbYellow
                .Turn5_Out.FillColor = vbYellow
            
            End If
        
    End Select
    
    End With
    
End Sub

