// test dcc with console
#include <iostream.h>
#include <stdio.h>
#include "DCC_comm.h"


// *****************************************************************************
// Module: DCC_	test.cpp 
// Type: C++/C  console main program
// Platform: Intel/Win95/ms visual c++ 6.0
// Authors: D C Pankratz
// Date Created: April 29, 2001
//
// Purpose: Provide a test driver for the DCC_comm.dll functions that control 
//			Wangrow's System One Command Station to operate trains with decoders
//          using Digital Command Control (DCC) as specified by the NMRA 
//          standards and recommended practices.
//
// Description: Provides a menu to test the commands and functions in the dll.
//              +/-/! will execute faster/slower/Estop for the existing train.
//
// Modified: (DATE/AUTHOR/REASON/ACTIVITY)
//
// ***********************************************************************************				


void menu(void);
void  domotorcmd(unsigned long DCC_comm, int train_id, int direction, int speed);

void main() {
	char choice;
	char commport[5];
	int n, testvalue;
	int train_id, direction, speed;
	int fcn_state = 0;
	int function_no, value;
	char cmd_str[20];
    unsigned long DCC_comm;
      
   menu();
   do {
	cerr << ">"; cin >> choice;

	switch (choice) {
	case '0': case 'Q': case 'q':
		choice = 0;
		break;

	case ' ': case 'H': case 'h':
		menu();
		break;

	case '1': case'O': case 'o':
		cerr << "open\n";
		cout<< "\nCOM1 or COM2 :" << flush;
		 cin >> commport;
		if (DCC_open(commport, DCC_comm))
			cerr << commport << " open\n";	
		else
			cerr << "Cannot make connection with DCC Command Station\n";
		break;

	case '2': case 'C': case 'c':
		cerr << "close\n";
		DCC_close(DCC_comm);
		break;
		
	case '3': case 'T': case 't':
	    testvalue = 100;
		cerr << "test DCC commands\n";
		cerr << testvalue <<  " = testvalue before call\n";
//		DCC_testcommands(testvalue);
		cerr << testvalue << " = testvalue after call\n";
		break;
    
	case '4': case 'K': case 'k':
		cerr << "kill\n";
		if(	DCC_kill(DCC_comm) )
			cerr << "Power to main track cut\n";
		else
			cerr << "Kill failed\n";
		break;
    
	case '5': case 'R': case 'r':
		cerr << "reset\n";
		if(	DCC_reset(DCC_comm) )
			cerr << "Power to main track restored\n";
	      else
			cerr << "Reset failed\n";
		  break; 
		
	
	case '6': case 'M': case 'm':
		cerr << "motor\n";
		cerr << "Enter: train_id  direction(0-1)  speed(0-28) ";
		cin >> train_id >> direction >> speed;
		domotorcmd(DCC_comm, train_id, direction, speed);		
		break;
	
	case '7': case 'E': case 'e':
		cerr << "Emergency stop\n";
		cerr << "Enter: train_id ";
		cin >> train_id;
		if ( DCC_Estop(DCC_comm, train_id) )
			cerr << "train " << train_id << " stopped\n";
		else
			cerr << "Estop command not executed\n";
		break;

	case '8': case 'F': case 'f':
		cerr << "Enter: train_id  function_no(0-3) value(0-1) ";
		cin >> train_id >> function_no >> value;
//		n = DCC_function(DCC_comm, train_id, fcn_state, function_no, value);
		if (n == 0) 
			cerr << "function command not executed\n";
		else if (n == 1)
			cerr << "function command executed\n";
		break;
	
	case '9': case 'U': case 'u':
		cerr << "Enter DCC command (ASCII) w/o checksum ";
		cin >> cmd_str;
//		DCC_command( cmd_str);
		break;

	case '+':
		speed++;
		domotorcmd(DCC_comm, train_id, direction, speed);		
		break;
	
	case '-':
		speed--;
		domotorcmd(DCC_comm, train_id, direction, speed);		
		break;
		
	case '!':
		if ( DCC_Estop(DCC_comm, train_id) )
			cerr << "train " << train_id << " stopped\n";
		else
			cerr << "Estop command not executed\n";
		break;

	default:
		cerr << "\nInvalid menu choice\n";
	} //switch
	} while (choice != 0);

return;
} //main

void menu() {
	cout << "0.  <Q>uit\n";
	cout << "H.  <H>elp - menu\n";
	cout << "1.  <O>pen connection to DCC\n";
	cout << "2.  <C>lose connection to DCC\n";
	cout << "3.  <T>est DCC command station\n";
	cout << "4.  <K>ill layout Emergency Stop\n";
	cout << "5.  <R>eset the system\n";
	cout << "6.  <M>otor command\n";
	cout << "7.  <B>rake\n";
	cout << "8.  <F>unction command\n";
	cout << "9.  <U>ser generated command\n";
	cout << "....<+> faster - current train\n";
	cout << "....<-> slower - current train\n";
	cout << "....<!> Estop  - current train\n"; 
	cout << "" << flush;
	return;
} // menu

void  domotorcmd(unsigned long DCC_comm, int train_id, int direction, int speed) {
	int n;
		n = DCC_motor(DCC_comm, train_id, direction, speed);
		if (n == 0) 
			cerr << "motor command failed to execute\n";
		else if (n == 1)
			cerr << "Motor command executed\n";
		else if(n == 2)
			cerr << "train_id rejected by command station\n";
		else if(n == 3)
			cerr << "invalid direction\n";
		else if (n == 3)
			cerr << "invalid speed\n";
		else
			cerr << "returned an invalid value\n";
		return;
} // domotorcmd




//==================================================

  




