/*--------------------------------------------------------------------------
 95SAMPLE.C

	This program is an example of how to use the Industrial Computer Source
	Peek Poke driver.  
	
	Please follow the installtation directions for the Peek Poke driver
	before attempting to compile and run.
	  
	To compile this code please ensure that your compiler has PPLIB95.LIB 
	set to link to, and that /NODEFAULTLIB:libcd.lib is added to the 
	linker options.

	As the following code is relatively self explainatory the only comments
	made in the code are for the use of the Peek Poke driver.

  ------------------------------------------------------------------------*/




#include <windows.h>
#include <stdio.h>
#include "pplib95.h"

#define IDC_WRITE	1
#define IDC_WRITE2	2
#define IDC_WRITE4	3
#define IDC_READ	4
#define IDC_READ2	5
#define IDC_READ4	6
#define IDC_EXIT	7
#define IDE_WRITE	8
#define IDE_WRITE2  9
#define IDE_WRITE4  10
#define IDE_READ	11
#define IDE_READ2	12
#define IDE_READ4	13
#define IDS_STATIC1	14
#define IDS_STATIC2 15
#define IDS_STATIC3 16
#define IDS_STATIC4 17
#define IDE_PORT	18

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM) ;

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
     {
     static char szAppName[] = "PPSample" ;

	 PVOID p;
	 UCHAR *ptr;
	 
     HWND        hwnd ;
     MSG         msg ;
     WNDCLASSEX  wndclass ;

	 wndclass.cbSize        = sizeof (wndclass) ;
     wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
     wndclass.lpfnWndProc   = WndProc ;
     wndclass.cbClsExtra    = 0 ;
     wndclass.cbWndExtra    = 0 ;
     wndclass.hInstance     = hInstance ;
     wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
     wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
     wndclass.hbrBackground = (HBRUSH) GetStockObject (LTGRAY_BRUSH) ;
     wndclass.lpszMenuName  = NULL ;
     wndclass.lpszClassName = szAppName ;
	 wndclass.hIconSm       = LoadIcon (NULL, IDI_APPLICATION) ;

     RegisterClassEx (&wndclass) ;

     hwnd = CreateWindow (szAppName, "Industrial Computer Source Peek Poke Sample",
                          WS_OVERLAPPEDWINDOW,
                          0, 0, 500, 350,
                          NULL, NULL, hInstance, NULL) ;

	 if(! ics_pp_open())			//Tests for proper opening of the 
	 {								//Peek Poke driver
		MessageBox(hwnd, "Peek Poke Driver failed to open",
		szAppName, MB_ICONEXCLAMATION | MB_OK);
		return FALSE;
	 }
	 
	 p = ics_pp_make_pointer (0xC0, 0x01); //Creates a pointer to the Peek
	 ptr = (UCHAR *) p;					   //Poke driver

	 ShowWindow (hwnd, iCmdShow) ;
     UpdateWindow (hwnd) ;

     while (GetMessage (&msg, NULL, 0, 0))
          {
          TranslateMessage (&msg) ;
          DispatchMessage (&msg) ;
          }

	 ics_pp_release_pointer (p, 0x01);		//Releases the pointer
	 ics_pp_close();						//Closes the pointer
     return msg.wParam ;
     }

LRESULT CALLBACK WndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
     {
     static HWND  hwndButton[7] ;
	 static HWND  hwndEdit[7];
	 static HWND  hwndStatic[4];
     static RECT  rect ;
     static int   cxChar, cyChar ;
     char		  szBuffer[50];
	 USHORT		  ioport;
	 ULONG		  dataval, readval;
	 HDC          hdc ;
     int          iLength;
     TEXTMETRIC   tm ;

     switch (iMsg)
          {
          case WM_CREATE :
				hdc = GetDC (hwnd) ;
				SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT)) ;
				GetTextMetrics (hdc, &tm) ;
				cxChar = tm.tmAveCharWidth ;
				cyChar = tm.tmHeight + tm.tmExternalLeading ;
				ReleaseDC (hwnd, hdc) ;

				hwndButton[0] = CreateWindow ("button", "Write Byte",
					WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
					10, 160, 120, 25,
					hwnd, (HMENU) IDC_WRITE,
					((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

			    hwndButton[1] = CreateWindow ("button", "Write 2 Bytes",
                    WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
                    10, 195, 120, 25,
                    hwnd, (HMENU) IDC_WRITE2,
                    ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

			    hwndButton[2] = CreateWindow ("button", "Write 4 Bytes",
                    WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
                    10, 230, 120, 25,
                    hwnd, (HMENU) IDC_WRITE4,
                    ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

				hwndButton[3] = CreateWindow ("button", "Read Byte",
                    WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
                    360, 160, 120, 25,
                    hwnd, (HMENU) IDC_READ,
                    ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

				hwndButton[4] = CreateWindow ("button", "Read 2 Bytes",
                    WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
                    360, 195, 120, 25,
                    hwnd, (HMENU) IDC_READ2,
                    ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

				hwndButton[5] = CreateWindow ("button", "Read 4 Bytes",
                    WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
                    360, 230, 120, 25,
                    hwnd, (HMENU) IDC_READ4,
                    ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

				hwndButton[6] = CreateWindow ("button", "E&xit",
                    WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
                    180, 280, 120, 25,
                    hwnd, (HMENU) IDC_EXIT,
                    ((LPCREATESTRUCT) lParam) -> hInstance, NULL) ;

				hwndEdit[0] = CreateWindow("edit", "FF",
				    WS_CHILD | WS_VISIBLE | WS_BORDER | SS_SUNKEN | ES_LEFT,
				    150, 160, 30, 25,
				    hwnd, (HMENU) IDE_WRITE,
				    ((LPCREATESTRUCT) lParam) -> hInstance, NULL);

				hwndEdit[1] = CreateWindow("edit", "FFFF",
				    WS_CHILD | WS_VISIBLE | WS_BORDER | ES_LEFT,
				    150, 195, 50, 25,
				    hwnd, (HMENU) IDE_WRITE2,
				    ((LPCREATESTRUCT) lParam) -> hInstance, NULL);

				hwndEdit[2] = CreateWindow("edit", "FFFFFFFF",
				    WS_CHILD | WS_VISIBLE | WS_BORDER | ES_LEFT,
				    150, 230, 70, 25,
				    hwnd, (HMENU) IDE_WRITE4,
				    ((LPCREATESTRUCT) lParam) -> hInstance, NULL);

				hwndEdit[3] = CreateWindow("edit", "FF",
				    WS_CHILD | WS_VISIBLE | WS_BORDER | ES_READONLY | ES_LEFT,
				    310, 160, 30, 25,
				    hwnd, (HMENU) IDE_READ,
				    ((LPCREATESTRUCT) lParam) -> hInstance, NULL);

				hwndEdit[4] = CreateWindow("edit", "FFFF",
				    WS_CHILD | WS_VISIBLE | WS_BORDER | ES_READONLY | ES_LEFT,
				    290, 195, 50, 25,
				    hwnd, (HMENU) IDE_READ2,
				    ((LPCREATESTRUCT) lParam) -> hInstance, NULL);
								
				hwndEdit[5] = CreateWindow("edit", "FFFFFFFF",
				    WS_CHILD | WS_VISIBLE | WS_BORDER | ES_READONLY ,
				    270, 230, 70, 25,
				    hwnd, (HMENU) IDE_READ4,
				    ((LPCREATESTRUCT) lParam) -> hInstance, NULL);

				hwndEdit[6] = CreateWindow("edit", "I/O Port",
				    WS_CHILD | WS_VISIBLE | WS_BORDER | ES_LEFT,
				    220, 70, 60, 25,
				    hwnd, (HMENU) IDE_PORT,
				    ((LPCREATESTRUCT) lParam) -> hInstance, NULL);

				hwndStatic[0] = CreateWindow("static",
					"All Numbers are in HEXADECIMAL",
					WS_CHILDWINDOW | WS_VISIBLE | SS_LEFT,
					20,	20, 290, 30,
					hwnd, (HMENU) IDS_STATIC1,
					((LPCREATESTRUCT) lParam) -> hInstance, NULL);

				hwndStatic[1] = CreateWindow("static",
					"Value to write",
					WS_CHILDWINDOW | WS_VISIBLE | SS_LEFT,
				    150, 135, 150, 25,
					hwnd, (HMENU) IDS_STATIC2,
					((LPCREATESTRUCT) lParam) -> hInstance, NULL);

				hwndStatic[2] = CreateWindow("static",
					"Value Read",
					WS_CHILDWINDOW | WS_VISIBLE | SS_LEFT,
				    265, 135, 150, 25,
					hwnd, (HMENU) IDS_STATIC3,
					((LPCREATESTRUCT) lParam) -> hInstance, NULL);


				hwndStatic[3] = CreateWindow("static",
					"I/O Port for Read or Write",
					WS_CHILDWINDOW | WS_VISIBLE | SS_CENTER,
                    160, 45, 200, 25,
					hwnd, (HMENU) IDS_STATIC4,
					((LPCREATESTRUCT) lParam) -> hInstance, NULL);

				return 0 ;

          case WM_COMMAND:
			  switch(LOWORD(wParam))
			  {

			  case IDC_WRITE:
				  iLength = GetWindowTextLength (hwndEdit[6]) + 1;
				  iLength = GetWindowText(hwndEdit[6], szBuffer, iLength);
				  sscanf(szBuffer, "%X", &ioport);
				  readval = ics_pp_inp(ioport);  //Calls Peek Poke to write
				  iLength = GetWindowTextLength (hwndEdit[0]) + 1;
				  iLength = GetWindowText(hwndEdit[0], szBuffer, iLength);
				  sscanf(szBuffer, "%X", &dataval);
				  ics_pp_outp(ioport, dataval);
				  SetWindowText(hwndEdit[0], szBuffer);
				  return 0;

			  case IDC_WRITE2:
				  iLength = GetWindowTextLength (hwndEdit[6]) + 1;
				  iLength = GetWindowText(hwndEdit[6], szBuffer, iLength);
  				  sscanf(szBuffer, "%X", &ioport);
				  readval = ics_pp_inp(ioport);  //Calls Peek Poke to write
				  iLength = GetWindowTextLength (hwndEdit[1]) + 1;
				  iLength = GetWindowText(hwndEdit[1], szBuffer, iLength);
				  sscanf(szBuffer, "%X", &dataval);
				  ics_pp_outp(ioport, dataval);
				  SetWindowText(hwndEdit[1], szBuffer);
				  return 0;

			  case IDC_WRITE4:
				  iLength = GetWindowTextLength (hwndEdit[6]) + 1;
				  iLength = GetWindowText(hwndEdit[6], szBuffer, iLength);
				  sscanf(szBuffer, "%X", &ioport);
				  readval = ics_pp_inp(ioport);  //Calls Peek Poke to write
				  iLength = GetWindowTextLength (hwndEdit[2]) + 1;
				  iLength = GetWindowText(hwndEdit[2], szBuffer, iLength);
				  sscanf(szBuffer, "%X", &dataval);
				  ics_pp_outp(ioport, dataval);
				  SetWindowText(hwndEdit[2], szBuffer);
				  return 0;

			  case IDC_READ:
  				  iLength = GetWindowTextLength (hwndEdit[6]) + 1;
				  iLength = GetWindowText(hwndEdit[6], szBuffer, iLength);
				  sscanf(szBuffer, "%X", &ioport);
				  dataval = ics_pp_inp(ioport);  //Calls Peek Poke to read
				  sprintf(szBuffer, "%.2X", dataval);
				  SetWindowText(hwndEdit[3], szBuffer);
				  return 0;

			  case IDC_READ2:
				  iLength = GetWindowTextLength (hwndEdit[6]) + 1;
				  iLength = GetWindowText(hwndEdit[6], szBuffer, iLength);
				  sscanf(szBuffer, "%X", &ioport);
				  dataval = ics_pp_inp(ioport); //Calls Peek Poke to read
				  sprintf(szBuffer, "%.4X", dataval);
				  SetWindowText(hwndEdit[4], szBuffer);
				  return 0;

			  case IDC_READ4:
				  iLength = GetWindowTextLength (hwndEdit[6]) + 1;
				  iLength = GetWindowText(hwndEdit[6], szBuffer, iLength);
				  sscanf(szBuffer, "%X", &ioport);
				  dataval = ics_pp_inp(ioport); //Calls Peek Poke to read
				  sprintf(szBuffer, "%.8X", dataval);
				  SetWindowText(hwndEdit[5], szBuffer);
				  return 0;

			  case IDC_EXIT:
				  SendMessage(hwnd, WM_DESTROY, 0, 0);
				  return 0;
			  }


		  case WM_SIZE :
               rect.left   = 24 * cxChar ;
               rect.top    =  2 * cyChar ;
               rect.right  = LOWORD (lParam) ;
               rect.bottom = HIWORD (lParam) ;
               return 0 ;


          case WM_DESTROY :
               PostQuitMessage (0) ;
               return 0 ;
          }
     return DefWindowProc (hwnd, iMsg, wParam, lParam) ;
     }
